%define section free

Summary:        Java class file and bytecode library and editor
Name:           jclasslib
Version:        2.0
Release:        1jpp
Epoch:          0
Group:          Development/Libraries/Java
License:        GPL
URL:            http://jclasslib.sourceforge.net/
Source0:        http://download.sf.net/jclasslib/jclasslib_unix_2_0.tar.gz
Source1:        %{name}.sh
Source2:        %{name}.desktop
Patch0:         %{name}-taskdefs.patch
Patch1:         %{name}-crosslink.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root
Vendor:         JPackage Project
Distribution:   JPackage

BuildArch:      noarch
BuildRequires:  ant, jpackage-utils >= 0:1.5, /usr/bin/perl, kunststoff
BuildRequires:  java-javadoc
Requires:       kunststoff, jpackage-utils >= 0:1.5

%description
jclasslib is a library that enables developers to read, modify and
write Java class files and bytecode. In addition, jclasslib contains a
class file viewer that visualizes all aspects of Java class files and
the contained bytecode.
While the bytecode manipulation library is of interest to developers
with specialized development targets such as obfuscators, compilers or
code completion engines, the class file viewer is a standalone
application which is useful for anyone trying to learn more about the
Java virtual machine.

%package        javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description    javadoc
Javadoc for %{name}

%package        scripts
Group:          Development/Libraries/Java
Summary:        Scripts for %{name}
Requires:       %{name} = %{epoch}:%{version}-%{release}
Requires:       jpackage-utils >= 0:1.5

%description    scripts
Scripts for %{name}.

%package        manual
Summary:        Manual for %{name}
Group:          Development/Libraries/Java

%description    manual
Manual for %{name}.


%prep
%setup -q -n %{name}
%patch0 -p0
%patch1 -p0
find . -name "*.jar" | xargs rm -f
mkdir lib
rm -rf doc/api/*


%build
# TODO: build netbeans stuff
export CLASSPATH=$(build-classpath kunststoff)
ant -Dbuild.compiler=modern -Dj2se.javadoc=%{_javadocdir}/java jar javadoc


%install
rm -rf $RPM_BUILD_ROOT

# jars
mkdir -p $RPM_BUILD_ROOT%{_javadir}
cp -p build/%{name}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}-%{version}.jar
ln -s %{name}-%{version}.jar $RPM_BUILD_ROOT%{_javadir}/%{name}.jar

# javadocs
mkdir -p $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
cp -pr doc/api/* $RPM_BUILD_ROOT%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} $RPM_BUILD_ROOT%{_javadocdir}/%{name} # ghost symlink

# scripts
mkdir -p $RPM_BUILD_ROOT%{_bindir}
cp -p %{SOURCE1} $RPM_BUILD_ROOT%{_bindir}/%{name}

# desktop entry
mkdir -p $RPM_BUILD_ROOT%{_datadir}/applications
cp -p %{SOURCE2} \
  $RPM_BUILD_ROOT%{_datadir}/applications/jpackage-%{name}.desktop
install -D -p -m 644 service/jclasslib16x16.png \
  $RPM_BUILD_ROOT%{_datadir}/icons/locolor/16x16/%{name}.png
install -D -p -m 644 service/jclasslib32x32.png \
  $RPM_BUILD_ROOT%{_datadir}/icons/locolor/32x32/%{name}.png
install -D -p -m 644 service/jclasslib32x32.png \
  $RPM_BUILD_ROOT%{_datadir}/pixmaps/%{name}.png


%clean
rm -rf $RPM_BUILD_ROOT


%post javadoc
rm -f %{_javadocdir}/%{name}
ln -s %{name}-%{version} %{_javadocdir}/%{name}


%files
%defattr(0644,root,root,0755)
%{_javadir}/*

%files javadoc
%defattr(0644,root,root,0755)
%doc %{_javadocdir}/%{name}-%{version}
%ghost %doc %{_javadocdir}/%{name}

%files scripts
%defattr(0755,root,root,0755)
%{_bindir}/*
%{_datadir}/applications/*
%{_datadir}/pixmaps/*
%{_datadir}/icons/*

%files manual
%defattr(0644,root,root,0755)
%doc doc/{doc.css,help.html,images}


%changelog
* Wed Sep 24 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:2.0-1jpp
- Update to 2.0.
- Crosslink with local J2SE javadocs.
- Save .spec in UTF-8, some cleanups.

* Fri Apr 25 2003 Ville Skyttä <ville.skytta at iki.fi> - 0:1.2-1jpp
- First JPackage release.
